local bump = require 'lib/bump'
local inspect = require "lib/inspect"

local world
local player
local blocks = {}

local function addBlock(x,y,w,h)
   	local block = {x=x, y=y, w=w, h=h}
    blocks[#blocks+1] = block
   	world:add(block, x,y,w,h)
end

function love.load(arg)
    -- varibles
   	world = bump.newWorld()
   	player = {x=33, y=33, w=16, h=16, yvel = 0, speed = 200, col = 0, len = 0, onGround=false}
   	world:add(player, player.x,player.y, player.w, player.h)

    -- graphics
    simpleWood = love.graphics.newImage("img/simple_wood.png")
    love.graphics.setBackgroundColor(239,255,205)


    -- Tiles
   	local tileTable = {
   						{0,0,0,0,0,0},
                        {0,0,0,0,0,0},
                        {1,1,1,1,1,1,1,1,1,1},
                        {1,0,0,0,0,0,0,0,0,0},
                        {1,0,0,0,0,0,0,0,0,0},
                        {1,1,1,1,1,1,1,1,1,1}
   					}
   	
    for rowIndex=1, #tileTable do
        local row = tileTable[rowIndex]
        for columnIndex=1, #row do
            local number = row[columnIndex]
            local x = (columnIndex-1)*32
            local y = (rowIndex-1)*32
            if number == 1 then
                addBlock(x, y, 32, 32)
            end
        end
    end

    print(#blocks)
end

function love.update(dt)
    
   	-- update the player.x and player.y when arrow keys are pressed
   	
   	if love.keyboard.isDown('a') then
      	player.x = player.x - player.speed * dt
   	end
   	if love.keyboard.isDown('d') then
      	player.x = player.x + player.speed * dt
   	end

    
    

   	-- local cols, len
    -- local _, _, cols, len = world:check(player, player.x, player.y)

    -- print debug-
    if player.yvel ~= 0 then
        for i=len,1,-1 do
            if cols[i].normal.y == 1 then
                player.yvel = 0
                player.onGround = true
            end
        end
    end
    if not player.onGround then
    end
    

    -- update the player associated bounding box in the world
    newX, newY, cols, len = world:move(player, player.x, player.y)
    player.x, player.y = newX, newY    

end

function love.draw(dt)
    love.graphics.setColor(46,38,51)
   	love.graphics.rectangle('fill', player.x, player.y, player.w, player.h)
   	for i=1, #blocks do
      	local b = blocks[i]
        love.graphics.setColor(255,255,255)
      	love.graphics.draw(simpleWood, b.x, b.y)
   end
end

function love.keypressed(key)
    local dt = love.timer.getDelta()
    if key == "escape" then
        love.event.quit()
    end
    if key == " " then
        player.yvel = 0
        player.yvel = -300
    end
    if key == "p" then
        print(inspect(cols))
    end
end